import setuptools
from django_mix_admin import __version__ as version

with open('README.md', 'r', encoding='utf-8') as fh:
    long_description = fh.read()

setuptools.setup(
    name="django-mix-admin",
    version=version,
    author="Eric Long",
    author_email="longminxiang@163.com",
    description="django admin plus",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://gitee.com/ericL/django_mix_admin",
    packages=setuptools.find_packages(),
    include_package_data=True,
    install_requires=['django>=2.0.0,<3.0.0'],
    classifiers=[
        'Development Status :: 5 - Production/Stable',
        'Environment :: Web Environment',
        'Framework :: Django',
        'Framework :: Django :: 2.2',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: MIT License',
        'Operating System :: OS Independent',
        'Programming Language :: Python',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.6',
        'Programming Language :: Python :: 3.7',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
        'Topic :: Software Development :: Libraries :: Python Modules',
        'Topic :: System :: Systems Administration :: Authentication/Directory',
    ],
)
